package com.vandyo.sentry.core.collectionMachine;

import com.vandyo.sentry.core.config.CheckMetaConfig;
import com.vandyo.sentry.core.dto.ErrStatus;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.stereotype.Component;

import java.util.Map;

@Component
@Slf4j
public class EmailDealer extends DataClearDealer {

    @Autowired
    private JavaMailSender javaMailSender;
    @Autowired
    private CheckMetaConfig checkMetaConfig;

    @Override
    public void deal(Map<String, Map<ErrStatus, Long>> data) {
        String content = formatData(data, checkMetaConfig.getDesMap());
        SimpleMailMessage message = new SimpleMailMessage();
        // FIXME: 更换为部门邮件应该更好！
        message.setFrom("zhouzihao@vandyo.com");
        message.setSubject("[服务报错]");
        message.setText(content);
        for (String email : checkMetaConfig.getEmailList()) {
            try {
                message.setTo(email);
                javaMailSender.send(message);
                log.info("email send to [{}]",email);
            } catch (Exception e) {
                log.error("Can not send email: {}", e.getLocalizedMessage());
            }
        }
    }
}
